# Categories

Categories can be used to group different shortcuts together into separate tabs inside the app. Each category has a name and can contain zero or more shortcuts. You can switch between categories while on the app's main screen by swiping horizontally or by selecting the tab at the top of the screen below the title bar.

### Managing Categories

You can access the categories editor via the "Categories" option in the dropdown menu in the app's main screen.

### Layout Types

A category's layout type defines how shortcuts within it are displayed. There are currently only 4 options: list, which will display the shortcuts vertically below each other in a list, and 3 different types of grid, where shortcuts are displayed in a grid, similar to Android's home screen.

### Backgrounds

You can change a category's background to either use the default color (i.e., white or black, depending on whether dark mode is enabled) or set it to a specific color.

### Hidden Categories

A category can be set to be hidden. A hidden category will not show up as a tab in the app. This can be useful if you have shortcuts that you only want to access directly from the home screen (make sure to place them first before hiding the category) or that you only want to trigger from other shortcuts, using [Scripting](scripting.md#trigger-shortcut)
 or via a [Multi-Shortcut](shortcuts.md#multi-shortcut).
