# Privacy Policy

With the exception of Crash Reporting and the Remote Edit ("Edit on Computer") feature (see below for these), all data entered into the app is only ever sent to the servers specified by the user through the use of shortcuts. No data about the user, their activity or device is collected or sent to the developer or any other third-party as part of this app.

<a name="crash-reporting"></a>
## Crash Reporting
The app uses the third-party service [Bugsnag](https://www.bugsnag.com/) to collect diagnostic data in the event of an app crash ("crash reports"). This serves the purpose of discovering and fixing bugs in the app. The collected data contains basic information about the device (e.g. manufacturer, language, OS version) and the crash itself (e.g. stacktrace, time of occurrence). No personal identifiable information such as usernames, email addresses, IP addresses or physical location is collected. The crash data is only used by the developer for debugging purposes. All collected data is automatically deleted after 7 days.

The user has the option to opt-out of the sending of these crash reports by changing their settings in the app.

If the app is installed from *F-Droid* then this crash reporting is automatically disabled and can not be enabled.

## Remote Editing ("Edit on Computer")

The "Edit on Computer" feature requires the use of a remote server. By default, this server is available at [https://http-shortcuts.rmy.ch/editor](https://http-shortcuts.rmy.ch/editor), provided by the developer himself. If the user wishes to make use of this feature, they consent that all their app's data (shortcuts, categories, variables) is pushed to the remote service, where it is accessible via a device ID and a password set by the user. This data is only used for the purpose of the remote editing feature itself and is not used in any other way (not even analytics or user event tracking) or by any party other than the user. The data is automatically deleted from the remote server 2 hours after pushing from the app or saving changes from the respective web app.

The user has the option to change to a different remote server from within the app, in which case the privacy policy of that server applies instead of the one for the default server.

The use of this feature is non-essential and the app can otherwise be fully used without the "Edit on Computer" feature.

## Permissions

The app may request some sensitive permissions, in particular the permission for reading the device's precise location. All of the data and functionality accessed through these permissions is used solely for the declared purpose. For details, see the [Permissions](permissions.md) page.

